;;; -*- Mode: Lisp; Package: WINAPI -*-
;;; winapi/commdlg.l

;; Copyright (C) 2001-2005 OHKUBO Hiroshi <ohkubo@s53.xrea.com>

;; Author: OHKUBO Hiroshi <ohkubo@s53.xrea.com>
;; Time-stamp: <2005/10/31 23:28:18 +0900>

;;; Commentary:

;; Description:
;;
;;  R_CAOgp邽߂̃Cu
;;

;; Installation:
;;
;;      1. A[JCuWJ commdlg.l  $XYZZY/site-lisp/winapi 
;;         Rs[܂B
;;
;;      2. oCgRpC܂B
;;
;;              M-x byte-compile-file
;;              Byte compile file: $XYZZY/site-lisp/winapi/commdlg.l
;;
;;      3. ~/.xyzzy ܂ $XYZZY/site-lisp/siteinit.l Ɉȉ̃R[h
;;         ǉ܂B
;;
;;              (require "winapi/commdlg")
;;
;;      4. L̐ݒ𔽉f邽߂ɁAxyzzy ċN܂B
;;         siteinit.l ɋLqꍇ Ctrl L[ Shift L[Ȃ
;;         xyzzy ċNA_vt@Cč\z܂B
;;

;; Uninstallation:
;;
;;      1. commdlg.l ɊւLq폜܂B
;;
;;      2. siteinit.l ɋLqĂꍇ Ctrl L[ Shift L[
;;         Ȃ xyzzy ċNA_vt@Cč\z܂B
;;

;; Setting example:
;;
;;      (require "winapi/commdlg")
;;

;; Example:
;;
;;      (require "winapi/commdlg")
;;      (defun sample-choose-color-dialog ()
;;        (let (color custom-color-list)
;;          (loop
;;            (multiple-value-setq (color custom-color-list)
;;              (win-user::choose-color-dialog
;;               :color color
;;               :custom-color-list custom-color-list))
;;            (if color
;;                (progn
;;                  (format t "#~6,'0X~%" color)
;;                  (refresh-screen))
;;              (return)))))
;;      (defun sample-choose-font-dialog (&optional font-data dialog-flags)
;;        (loop
;;          (setq font-data
;;                (apply 'win-user::choose-font-dialog (append font-data dialog-flags)))
;;          (if font-data
;;              (progn
;;                (format t "~S~%" font-data)
;;                (refresh-screen))
;;            (return))))
;;
;;      (sample-choose-color-dialog)
;;      (sample-choose-font-dialog
;;       '(:face-name "lr SVbN")
;;       '(:cf-effects t :cf-fixed-pitch-only t :cf-no-vert-fonts t :cf-select-script t))
;;


;; Changes:
;;
;;      Mon, 31 Oct 2005 00:25:56 +0900
;;        Ewin-user::choose-font-dialog ֐ǉB
;;
;;      Fri, 28 Oct 2005 01:57:47 +0900
;;        ErgbResult ̒l擾 si:unpack-int32 gp悤ɁB
;;
;;      Mon, 17 Oct 2005 21:39:23 +0900
;;        Eō쐬
;;
;;      Sun, 16 Oct 2005 22:19:29 +0900
;;        E쐬Jn
;;

;; Licence:
;;
;;    commdlg ͏CBSDCZXɊÂėp\łB
;;    <http://www.opensource.org/licenses/bsd-license.php>
;;
;;
;;    Copyright (C) 2001-2005, OHKUBO Hiroshi.  All rights reserved.
;;
;;    Redistribution and use in source and binary forms, with or without
;;    modification, are permitted provided that the following conditions
;;    are met:
;;
;;    1. Redistributions of source code must retain the above copyright
;;       notice, this list of conditions and the following disclaimer.
;;
;;    2. Redistributions in binary form must reproduce the above copyright
;;       notice, this list of conditions and the following disclaimer in
;;       the documentation and/or other materials provided with the
;;       distribution.
;;
;;    3. Neither the name of the University nor the names of its
;;       contributors may be used to endorse or promote products derived
;;       from this software without specific prior written permission.
;;
;;    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
;;    ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;;    LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
;;    A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
;;    OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
;;    SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
;;    LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
;;    DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
;;    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
;;    (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
;;    OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
;;

;;; Code:

(provide "winapi/commdlg")

(eval-when (:compile-toplevel :load-toplevel :execute)
  (require "foreign")
  (require "wip/winapi"))

(in-package "winapi")

;;; wtypes.h

;(*define-c-type void VOID)
(*define-c-type (void *) VOID)

;;; windef.h

(*define FALSE 0)
(*define TRUE  1)

;;; winuser.h

(*define WM_USER #x0400)

;#if(WINVER >= 0x0400)
(*define-c-struct NMHDR
  (HWND  hwndFrom)
  (UINT  idFrom  )
  (UINT  code    )); // NM_ code
(*define-c-type (NMHDR *) LPNMHDR)

(*define-c-struct STYLESTRUCT
  (DWORD   styleOld)
  (DWORD   styleNew))
(*define-c-type (STYLESTRUCT *) LPSTYLESTRUCT)
;#endif /* WINVER >= 0x0400 */

;;; wingdi.h

(*define-c-type (LOGFONT *) LPLOGFONT)
(*define FW_DONTCARE         0)
(*define FW_BOLD             700)

(*define LOGPIXELSX          88); /* Logical pixels/inch in X */
(*define LOGPIXELSY          90); /* Logical pixels/inch in Y */
(*define-dll-entry int GetDeviceCaps (HDC int) "gdi32")

;;; commdlg.h

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; GetOpenFileName, GetSaveFileName, GetFileTitle
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(*define-c-type (void *) LPOFNHOOKPROC)

(*define-c-struct OPENFILENAME
  (DWORD         lStructSize      )
  (HWND          hwndOwner        )
  (HINSTANCE     hInstance        )
  (LPCSTR        lpstrFilter      )
  (LPSTR         lpstrCustomFilter)
  (DWORD         nMaxCustFilter   )
  (DWORD         nFilterIndex     )
  (LPSTR         lpstrFile        )
  (DWORD         nMaxFile         )
  (LPSTR         lpstrFileTitle   )
  (DWORD         nMaxFileTitle    )
  (LPCSTR        lpstrInitialDir  )
  (LPCSTR        lpstrTitle       )
  (DWORD         Flags            )
  (WORD          nFileOffset      )
  (WORD          nFileExtension   )
  (LPCSTR        lpstrDefExt      )
  (LPARAM        lCustData        )
  (LPOFNHOOKPROC lpfnHook         )
  (LPCSTR        lpTemplateName   ))
(*define-c-type (OPENFILENAME *) LPOPENFILENAME)

(*define-dll-entry BOOL GetOpenFileName (LPOPENFILENAME) "comdlg32" "GetOpenFileNameA")
(*define-dll-entry BOOL GetSaveFileName (LPOPENFILENAME) "comdlg32" "GetSaveFileNameA")
(*define-dll-entry short GetFileTitle (LPCSTR LPSTR WORD) "comdlg32" "GetFileTitleA")

(*define OFN_READONLY                 #x00000001)
(*define OFN_OVERWRITEPROMPT          #x00000002)
(*define OFN_HIDEREADONLY             #x00000004)
(*define OFN_NOCHANGEDIR              #x00000008)
(*define OFN_SHOWHELP                 #x00000010)
(*define OFN_ENABLEHOOK               #x00000020)
(*define OFN_ENABLETEMPLATE           #x00000040)
(*define OFN_ENABLETEMPLATEHANDLE     #x00000080)
(*define OFN_NOVALIDATE               #x00000100)
(*define OFN_ALLOWMULTISELECT         #x00000200)
(*define OFN_EXTENSIONDIFFERENT       #x00000400)
(*define OFN_PATHMUSTEXIST            #x00000800)
(*define OFN_FILEMUSTEXIST            #x00001000)
(*define OFN_CREATEPROMPT             #x00002000)
(*define OFN_SHAREAWARE               #x00004000)
(*define OFN_NOREADONLYRETURN         #x00008000)
(*define OFN_NOTESTFILECREATE         #x00010000)
(*define OFN_NONETWORKBUTTON          #x00020000)
(*define OFN_NOLONGNAMES              #x00040000); force no long names for 4.x modules
;#if(WINVER >= 0x0400)
(*define OFN_EXPLORER                 #x00080000); new look commdlg
(*define OFN_NODEREFERENCELINKS       #x00100000)
(*define OFN_LONGNAMES                #x00200000); force long names for 3.x modules
(*define OFN_ENABLEINCLUDENOTIFY      #x00400000); send include message to callback
(*define OFN_ENABLESIZING             #x00800000)
;#endif /* WINVER >= 0x0400 */

;// Return values for the registered message sent to the hook function
;// when a sharing violation occurs.  OFN_SHAREFALLTHROUGH allows the
;// filename to be accepted, OFN_SHARENOWARN rejects the name but puts
;// up no warning (returned when the app has already put up a warning
;// message), and OFN_SHAREWARN puts up the default warning message
;// for sharing violations.
;//
;// Note:  Undefined return values map to OFN_SHAREWARN, but are
;//        reserved for future use.

(*define OFN_SHAREFALLTHROUGH     2)
(*define OFN_SHARENOWARN          1)
(*define OFN_SHAREWARN            0)

;#if(WINVER >= 0x0400)
;// Structure used for all file based OpenFileName notifications
(*define-c-struct OFNOTIFY
  (NMHDR           hdr    )
  (LPOPENFILENAME  lpOFN  )
  (LPSTR           pszFile)); // May be NULL
(*define-c-type (OFNOTIFY *) LPOFNOTIFY)

;// Structure used for all object based OpenFileName notifications
(*define-c-struct OFNOTIFYEX
  (NMHDR           hdr  )
  (LPOPENFILENAME  lpOFN)
  (LPVOID          psf  )
  (LPVOID          pidl )); // May be NULL
(*define-c-type (OFNOTIFYEX *) LPOFNOTIFYEX)

(*define CDN_FIRST   (- 0 601))
(*define CDN_LAST    (- 0 699))

;// Notifications when Open or Save dialog status changes
(*define CDN_INITDONE            (- CDN_FIRST #x0000))
(*define CDN_SELCHANGE           (- CDN_FIRST #x0001))
(*define CDN_FOLDERCHANGE        (- CDN_FIRST #x0002))
(*define CDN_SHAREVIOLATION      (- CDN_FIRST #x0003))
(*define CDN_HELP                (- CDN_FIRST #x0004))
(*define CDN_FILEOK              (- CDN_FIRST #x0005))
(*define CDN_TYPECHANGE          (- CDN_FIRST #x0006))
(*define CDN_INCLUDEITEM         (- CDN_FIRST #x0007))

(*define CDM_FIRST       (+ WM_USER 100))
(*define CDM_LAST        (+ WM_USER 200))

;// Messages to query information from the Open or Save dialogs

;// lParam = pointer to text buffer that gets filled in
;// wParam = max number of characters of the text buffer (including NULL)
;// return = < 0 if error; number of characters needed (including NULL)
(*define CDM_GETSPEC             (+ CDM_FIRST #x0000))
;#define CommDlg_OpenSave_GetSpecA(_hdlg, _psz, _cbmax) \
;        (int)SNDMSG(_hdlg, CDM_GETSPEC, (WPARAM)_cbmax, (LPARAM)(LPSTR)_psz)
(defun CommDlg_OpenSave_GetSpec (_hdlg _psz _cbmax)
  (SendMessage _hdlg CDM_GETSPEC _cbmax _psz))
(export '(CommDlg_OpenSave_GetSpec))

;// lParam = pointer to text buffer that gets filled in
;// wParam = max number of characters of the text buffer (including NULL)
;// return = < 0 if error; number of characters needed (including NULL)
(*define CDM_GETFILEPATH         (+ CDM_FIRST #x0001))
;#define CommDlg_OpenSave_GetFilePathA(_hdlg, _psz, _cbmax) \
;        (int)SNDMSG(_hdlg, CDM_GETFILEPATH, (WPARAM)_cbmax, (LPARAM)(LPSTR)_psz)
(defun CommDlg_OpenSave_GetFilePath (_hdlg _psz _cbmax)
  (SendMessage _hdlg CDM_GETFILEPATH _cbmax _psz))
(export '(CommDlg_OpenSave_GetFilePath))

;// lParam = pointer to text buffer that gets filled in
;// wParam = max number of characters of the text buffer (including NULL)
;// return = < 0 if error; number of characters needed (including NULL)
(*define CDM_GETFOLDERPATH       (+ CDM_FIRST #x0002))
;#define CommDlg_OpenSave_GetFolderPathA(_hdlg, _psz, _cbmax) \
;        (int)SNDMSG(_hdlg, CDM_GETFOLDERPATH, (WPARAM)_cbmax, (LPARAM)(LPSTR)_psz)
(defun CommDlg_OpenSave_GetFolderPath (_hdlg _psz _cbmax)
  (SendMessage _hdlg CDM_GETFOLDERPATH _cbmax _psz))
(export '(CommDlg_OpenSave_GetFolderPath))

;// lParam = pointer to ITEMIDLIST buffer that gets filled in
;// wParam = size of the ITEMIDLIST buffer
;// return = < 0 if error; length of buffer needed
(*define CDM_GETFOLDERIDLIST     (+ CDM_FIRST #x0003))
;#define CommDlg_OpenSave_GetFolderIDList(_hdlg, _pidl, _cbmax) \
;        (int)SNDMSG(_hdlg, CDM_GETFOLDERIDLIST, (WPARAM)_cbmax, (LPARAM)(LPVOID)_pidl)
(defun CommDlg_OpenSave_GetFolderIDList (_hdlg _pidl _cbmax)
  (SendMessage _hdlg CDM_GETFOLDERIDLIST _cbmax _pidl))
(export '(CommDlg_OpenSave_GetFolderIDList))

;// lParam = pointer to a string
;// wParam = ID of control to change
;// return = not used
(*define CDM_SETCONTROLTEXT      (+ CDM_FIRST #x0004))
;#define CommDlg_OpenSave_SetControlText(_hdlg, _id, _text) \
;        (void)SNDMSG(_hdlg, CDM_SETCONTROLTEXT, (WPARAM)_id, (LPARAM)(LPSTR)_text)
(defun CommDlg_OpenSave_SetControlText (_hdlg _id _text)
  (SendMessage _hdlg CDM_SETCONTROLTEXT _id _text))
(export '(CommDlg_OpenSave_SetControlText))

;// lParam = not used
;// wParam = ID of control to change
;// return = not used
(*define CDM_HIDECONTROL         (+ CDM_FIRST #x0005))
;#define CommDlg_OpenSave_HideControl(_hdlg, _id) \
;        (void)SNDMSG(_hdlg, CDM_HIDECONTROL, (WPARAM)_id, 0)
(defun CommDlg_OpenSave_HideControl (_hdlg _id)
  (SendMessage _hdlg CDM_HIDECONTROL _id 0))
(export '(CommDlg_OpenSave_HideControl))

;// lParam = pointer to default extension (no dot)
;// wParam = not used
;// return = not used
(*define CDM_SETDEFEXT           (+ CDM_FIRST #x0006))
;#define CommDlg_OpenSave_SetDefExt(_hdlg, _pszext) \
;        (void)SNDMSG(_hdlg, CDM_SETDEFEXT, 0, (LPARAM)(LPSTR)_pszext)
(defun CommDlg_OpenSave_SetDefExt (_hdlg _pszext)
  (SendMessage _hdlg CDM_SETDEFEXT 0 _pszext))
(export '(CommDlg_OpenSave_SetDefExt))
;#endif /* WINVER >= 0x0400 */

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ChooseColor
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(*define-c-type (void *) LPCCHOOKPROC)
(*define-c-type (COLORREF *) PCOLORREF)

(*define-c-struct CHOOSECOLOR
  (DWORD        lStructSize   ) ; \̂̃oCg
  (HWND         hwndOwner     ) ; _CAO̐eEBhẼnh
  (HWND         hInstance     ) ; ev[gp̃\[XW[̃CX^Xnh(gp0)
  (COLORREF     rgbResult     ) ; ĂяoO͏FAÍA[U[IF
  (PCOLORREF    lpCustColors  ) ; JX^J[zւ̃|C^
  (DWORD        Flags         ) ; w肷萔̑gݍ킹
  (LPARAM       lCustData     ) ; vV[Wɓn[U[`f[^
  (LPCCHOOKPROC lpfnHook      ) ; [U[`̃vV[Wւ̃|C^
  (LPCSTR       lpTemplateName)); ev[g
(*define-c-type (CHOOSECOLOR *) LPCHOOSECOLOR)

(*define-dll-entry BOOL ChooseColor (LPCHOOSECOLOR) "comdlg32" "ChooseColorA")

;; Flags ̒l (tO)
(*define CC_RGBINIT               #x00000001) ; rgbResultŏݒJ[ƂĎw肳ꂽJ[lftHgɂ
(*define CC_FULLOPEN              #x00000002) ; F쐬\
(*define CC_PREVENTFULLOPEN       #x00000004) ; [F쐬]{^𖳌ɂ
(*define CC_SHOWHELP              #x00000008) ; [wv]{^\
(*define CC_ENABLEHOOK            #x00000010) ; lpfnHoolŎw肳ꂽtbN֐Lɂ
(*define CC_ENABLETEMPLATE        #x00000020) ; ev[gg
(*define CC_ENABLETEMPLATEHANDLE  #x00000040) ; hInstanceɂLɂ
;#if(WINVER >= 0x0400)
(*define CC_SOLIDCOLOR            #x00000080) ; \bhJ[̂ݑI\ɂ
(*define CC_ANYCOLOR              #x00000100) ; gp\ȑSĂ̐F\
;#endif /* WINVER >= 0x0400 */

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; FindText, ReplaceText
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(*define-c-type (void *) LPFRHOOKPROC)

(*define-c-struct FINDREPLACE
  (DWORD        lStructSize     ) ; // size of this struct 0x20
  (HWND         hwndOwner       ) ; // handle to owner's window
  (HINSTANCE    hInstance       ) ; // instance handle of.EXE that
                                  ; //   contains cust. dlg. template
  (DWORD        Flags           ) ; // one or more of the FR_??
  (LPSTR        lpstrFindWhat   ) ; // ptr. to search string
  (LPSTR        lpstrReplaceWith) ; // ptr. to replace string
  (WORD         wFindWhatLen    ) ; // size of find buffer
  (WORD         wReplaceWithLen ) ; // size of replace buffer
  (LPARAM       lCustData       ) ; // data passed to hook fn.
  (LPFRHOOKPROC lpfnHook        ) ; // ptr. to hook fn. or NULL
  (LPCSTR       lpTemplateName  )); // custom template name
(*define-c-type (FINDREPLACE *) LPFINDREPLACE)

(*define FR_DOWN                 #x00000001) ; ɌČ
(*define FR_WHOLEWORD            #x00000002) ; PPʂŒT
(*define FR_MATCHCASE            #x00000004) ; 啶Əʂ
(*define FR_FINDNEXT             #x00000008) ; ̏oʒu܂Ō
(*define FR_REPLACE              #x00000010) ; ̌ʂu
(*define FR_REPLACEALL           #x00000020) ; SĂ̌ʂu
(*define FR_DIALOGTERM           #x00000040) ; _CAOĂ
(*define FR_SHOWHELP             #x00000080) ; uwvv{^\
(*define FR_ENABLEHOOK           #x00000100) ; lpfnHook L
(*define FR_ENABLETEMPLATE       #x00000200) ; ev[gg
(*define FR_NOUPDOWN             #x00000400) ; {^𖳌
(*define FR_NOMATCHCASE          #x00000800) ; 啶ƏʂȂ
(*define FR_NOWHOLEWORD          #x00001000) ; PPʂŒTȂ
(*define FR_ENABLETEMPLATEHANDLE #x00002000) ; hInstanceLɂ
(*define FR_HIDEUPDOWN           #x00004000) ; uv\
(*define FR_HIDEMATCHCASE        #x00008000) ; u啶Əʂv\
(*define FR_HIDEWHOLEWORD        #x00010000) ; uPPʂŒTv\

(*define-dll-entry HWND FindText (LPFINDREPLACE) "comdlg32" "FindTextA")
(*define-dll-entry HWND ReplaceText (LPFINDREPLACE) "comdlg32" "ReplaceTextA")

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ChooseFont
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(*define-c-type (void *) LPCFHOOKPROC)

(*define-c-struct CHOOSEFONT
  (DWORD           lStructSize   )
  (HWND            hwndOwner     ) ; // caller's window handle
  (HDC             hDC           ) ; // printer DC/IC or NULL
  (LPLOGFONT       lpLogFont     ) ; // ptr. to a LOGFONT struct
  (INT             iPointSize    ) ; // 10 * size in points of selected font
  (DWORD           Flags         ) ; // enum. type flags
  (COLORREF        rgbColors     ) ; // returned text color
  (LPARAM          lCustData     ) ; // data passed to hook fn.
  (LPCFHOOKPROC    lpfnHook      ) ; // ptr. to hook function
  (LPCSTR          lpTemplateName) ; // custom template name
  (HINSTANCE       hInstance     ) ; // instance handle of.EXE that
                                   ; //   contains cust. dlg. template
  (LPSTR           lpszStyle     ) ; // return the style field here
                                   ; // must be LF_FACESIZE or bigger
  (WORD            nFontType     ) ; // same value reported to the EnumFonts
                                   ; //   call back with the extra FONTTYPE_
                                   ; //   bits added
  (WORD            ___MISSING_ALIGNMENT__)
  (INT             nSizeMin      ) ; // minimum pt size allowed &
  (INT             nSizeMax      )); // max pt size allowed if
                                   ; //   CF_LIMITSIZE is used
(*define-c-type (CHOOSEFONT *) LPCHOOSEFONT)

(*define-dll-entry BOOL ChooseFont (LPCHOOSEFONT) "comdlg32" "ChooseFontA")

(*define CF_SCREENFONTS             #x00000001) ; VXeT|[gĂXN[tHĝݕ\
(*define CF_PRINTERFONTS            #x00000002) ; hDCoŎw肳ꂽfoCXReLXgT|[gtHĝݕ\
(*define CF_BOTH                    (logior CF_SCREENFONTS CF_PRINTERFONTS))
(*define CF_SHOWHELP                #x00000004) ; wv{^\
(*define CF_ENABLEHOOK              #x00000008) ; lpfnHook L
(*define CF_ENABLETEMPLATE          #x00000010) ; hInstance, lpTemplateName
(*define CF_ENABLETEMPLATEHANDLE    #x00000020) ; hInstance
(*define CF_INITTOLOGFONTSTRUCT     #x00000040) ; lpLogFontoŏ
(*define CF_USESTYLE                #x00000080) ; lpszStyleõX^Cf[^ŏ
(*define CF_EFFECTS                 #x00000100) ; łEEFw\
(*define CF_APPLY                   #x00000200) ; [Kp] {^\
(*define CF_ANSIONLY                #x00000400) ; OEMZbgV{ZbgIł悤
;#if(WINVER >= 0x0400)
(*define CF_SCRIPTSONLY             CF_ANSIONLY); OEMZbgV{ZbgIł悤
;#endif /* WINVER >= 0x0400 */
(*define CF_NOVECTORFONTS           #x00000800)      ; xNgtHgIłȂ悤
(*define CF_NOOEMFONTS              CF_NOVECTORFONTS); xNgtHgIłȂ悤
(*define CF_NOSIMULATIONS           #x00001000) ; GDItHgV~[VsȂȂ悤
(*define CF_LIMITSIZE               #x00002000) ; nSizeMinonSizeMaxoŁAtHgTCY͈̔͂𐧌
(*define CF_FIXEDPITCHONLY          #x00004000) ; Œsb`tHĝ݂Ił悤
(*define CF_WYSIWYG                 #x00008000) ; // must also have CF_SCREENFONTS & CF_PRINTERFONTS
                                                ; fBXvCƃv^̗Ŏgp\ȃtHĝ݂Ił悤
(*define CF_FORCEFONTEXIST          #x00010000) ; ݂ȂI[UꍇAG[Ԃ悤
(*define CF_SCALABLEONLY            #x00020000) ; XP[O\ȃtHĝݑI\
(*define CF_TTONLY                  #x00040000) ; TrueTypetHĝ݂I\
(*define CF_NOFACESEL               #x00080000) ; ԂŃtHg̃R{{bNXɉIĂȂ悤
(*define CF_NOSTYLESEL              #x00100000) ; ԂŃtHgX^C̃R{{bNXɉIĂȂ悤
(*define CF_NOSIZESEL               #x00200000) ; ԂŃtHgTCỸR{{bNXɉIĂȂ悤
;#if(WINVER >= 0x0400)
(*define CF_SELECTSCRIPT            #x00400000) ; lfCharSetoŎw肳ꂽZbgtHĝݕ\
(*define CF_NOSCRIPTSEL             #x00800000) ; Zbg̃R{{bNX𖳌
(*define CF_NOVERTFONTS             #x01000000) ; ̃tHĝ
;#endif /* WINVER >= 0x0400 */

;// these are extra nFontType bits that are added to what is returned to the
;// EnumFonts callback routine

(*define SIMULATED_FONTTYPE    #x8000) ; GDIɂăV~[g
(*define PRINTER_FONTTYPE      #x4000) ; v^tHg
(*define SCREEN_FONTTYPE       #x2000) ; XN[tHg
(*define BOLD_FONTTYPE         #x0100) ; 
(*define ITALIC_FONTTYPE       #x0200) ; C^bN
(*define REGULAR_FONTTYPE      #x0400) ; ʏ̑

;// EnumFonts callback routine only uses these bits, so we can use the rest

;// (*define RASTER_FONTTYPE     #x001)
;// (*define DEVICE_FONTTYPE     #x002)
;// (*define TRUETYPE_FONTTYPE   #x004)

;#ifdef WINNT
(*define OPENTYPE_FONTTYPE     #x10000)
(*define TYPE1_FONTTYPE        #x20000)
(*define DSIG_FONTTYPE         #x40000)
;#endif

(*define WM_CHOOSEFONT_GETLOGFONT      (+ WM_USER 1))
(*define WM_CHOOSEFONT_SETLOGFONT      (+ WM_USER 101))
(*define WM_CHOOSEFONT_SETFLAGS        (+ WM_USER 102))

;// strings used to obtain unique window message for communication
;// between dialog and caller

(*define LBSELCHSTRING  "commdlg_LBSelChangedNotify")
(*define SHAREVISTRING  "commdlg_ShareViolation")
(*define FILEOKSTRING   "commdlg_FileNameOK")
(*define COLOROKSTRING  "commdlg_ColorOK")
(*define SETRGBSTRING   "commdlg_SetRGBColor")
(*define HELPMSGSTRING  "commdlg_help")
(*define FINDMSGSTRING  "commdlg_FindReplace")

;// HIWORD values for lParam of commdlg_LBSelChangeNotify message
(*define CD_LBSELNOITEMS -1)
(*define CD_LBSELCHANGE   0)
(*define CD_LBSELSUB      1)
(*define CD_LBSELADD      2)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; PrintDlg
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(*define-c-type (void *) LPPRINTHOOKPROC)
(*define-c-type (void *) LPSETUPHOOKPROC)

(*define-c-struct PRINTDLG
  (DWORD            lStructSize        )
  (HWND             hwndOwner          )
  (HGLOBAL          hDevMode           )
  (HGLOBAL          hDevNames          )
  (HDC              hDC                )
  (DWORD            Flags              )
  (WORD             nFromPage          )
  (WORD             nToPage            )
  (WORD             nMinPage           )
  (WORD             nMaxPage           )
  (WORD             nCopies            )
  (HINSTANCE        hInstance          )
  (LPARAM           lCustData          )
  (LPPRINTHOOKPROC  lpfnPrintHook      )
  (LPSETUPHOOKPROC  lpfnSetupHook      )
  (LPCSTR           lpPrintTemplateName)
  (LPCSTR           lpSetupTemplateName)
  (HGLOBAL          hPrintTemplate     )
  (HGLOBAL          hSetupTemplate     ))
(*define-c-type (PRINTDLG *) LPPRINTDLG)

(*define-dll-entry BOOL PrintDlg (LPPRINTDLG) "comdlg32" "PrintDlgA")

(*define PD_ALLPAGES                    #x00000000)
(*define PD_SELECTION                   #x00000001)
(*define PD_PAGENUMS                    #x00000002)
(*define PD_NOSELECTION                 #x00000004)
(*define PD_NOPAGENUMS                  #x00000008)
(*define PD_COLLATE                     #x00000010)
(*define PD_PRINTTOFILE                 #x00000020)
(*define PD_PRINTSETUP                  #x00000040)
(*define PD_NOWARNING                   #x00000080)
(*define PD_RETURNDC                    #x00000100)
(*define PD_RETURNIC                    #x00000200)
(*define PD_RETURNDEFAULT               #x00000400)
(*define PD_SHOWHELP                    #x00000800)
(*define PD_ENABLEPRINTHOOK             #x00001000)
(*define PD_ENABLESETUPHOOK             #x00002000)
(*define PD_ENABLEPRINTTEMPLATE         #x00004000)
(*define PD_ENABLESETUPTEMPLATE         #x00008000)
(*define PD_ENABLEPRINTTEMPLATEHANDLE   #x00010000)
(*define PD_ENABLESETUPTEMPLATEHANDLE   #x00020000)
(*define PD_USEDEVMODECOPIES            #x00040000)
(*define PD_USEDEVMODECOPIESANDCOLLATE  #x00040000)
(*define PD_DISABLEPRINTTOFILE          #x00080000)
(*define PD_HIDEPRINTTOFILE             #x00100000)
(*define PD_NONETWORKBUTTON             #x00200000)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; CommDlgExtendedError
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(*define-c-struct DEVNAMES
  (WORD wDriverOffset)
  (WORD wDeviceOffset)
  (WORD wOutputOffset)
  (WORD wDefault     ))
(*define-c-type (DEVNAMES *) LPDEVNAMES)

(*define DN_DEFAULTPRN      #x0001)

(*define-dll-entry DWORD CommDlgExtendedError (VOID) "comdlg32")

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; PageSetupDlg
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;#if(WINVER >= 0x0400)
(*define WM_PSD_PAGESETUPDLG     WM_USER     )
(*define WM_PSD_FULLPAGERECT     (+ WM_USER 1))
(*define WM_PSD_MINMARGINRECT    (+ WM_USER 2))
(*define WM_PSD_MARGINRECT       (+ WM_USER 3))
(*define WM_PSD_GREEKTEXTRECT    (+ WM_USER 4))
(*define WM_PSD_ENVSTAMPRECT     (+ WM_USER 5))
(*define WM_PSD_YAFULLPAGERECT   (+ WM_USER 6))

(*define-c-type (void *) LPPAGEPAINTHOOK)
(*define-c-type (void *) LPPAGESETUPHOOK)

(*define-c-struct PAGESETUPDLG
  (DWORD           lStructSize            )
  (HWND            hwndOwner              )
  (HGLOBAL         hDevMode               )
  (HGLOBAL         hDevNames              )
  (DWORD           Flags                  )
  (POINT           ptPaperSize            )
  (RECT            rtMinMargin            )
  (RECT            rtMargin               )
  (HINSTANCE       hInstance              )
  (LPARAM          lCustData              )
  (LPPAGESETUPHOOK lpfnPageSetupHook      )
  (LPPAGEPAINTHOOK lpfnPagePaintHook      )
  (LPCSTR          lpPageSetupTemplateName)
  (HGLOBAL         hPageSetupTemplate     ))
(*define-c-type (PAGESETUPDLG *) LPPAGESETUPDLG)

(*define-dll-entry BOOL PageSetupDlg (LPPRINTDLG) "comdlg32" "PageSetupDlgA")

(*define PSD_DEFAULTMINMARGINS             #x00000000); // default (printer's)
(*define PSD_INWININIINTLMEASURE           #x00000000); // 1st of 4 possible

(*define PSD_MINMARGINS                    #x00000001); // use caller's
(*define PSD_MARGINS                       #x00000002); // use caller's
(*define PSD_INTHOUSANDTHSOFINCHES         #x00000004); // 2nd of 4 possible
(*define PSD_INHUNDREDTHSOFMILLIMETERS     #x00000008); // 3rd of 4 possible
(*define PSD_DISABLEMARGINS                #x00000010);
(*define PSD_DISABLEPRINTER                #x00000020);
(*define PSD_NOWARNING                     #x00000080); // must be same as PD_*
(*define PSD_DISABLEORIENTATION            #x00000100);
(*define PSD_RETURNDEFAULT                 #x00000400); // must be same as PD_*
(*define PSD_DISABLEPAPER                  #x00000200);
(*define PSD_SHOWHELP                      #x00000800); // must be same as PD_*
(*define PSD_ENABLEPAGESETUPHOOK           #x00002000); // must be same as PD_*
(*define PSD_ENABLEPAGESETUPTEMPLATE       #x00008000); // must be same as PD_*
(*define PSD_ENABLEPAGESETUPTEMPLATEHANDLE #x00020000); // must be same as PD_*
(*define PSD_ENABLEPAGEPAINTHOOK           #x00040000);
(*define PSD_DISABLEPAGEPAINTING           #x00080000);
(*define PSD_NONETWORKBUTTON               #x00200000); // must be same as PD_*
;#endif /* WINVER >= 0x0400 */


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; WIN-USER
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(in-package "win-user")

(export '(choose-color-dialog
          choose-font-dialog))

(defun choose-color-dialog (&key color custom-color-list
                                 manual-flags hwnd hinstance template-name lCustData lpfnHook)
  "FI_CAO\B
yz
color            : F̏l BBGGRR ŎwB(F #xFF0000)
                   w肳ȂꍇAVXeɂďl()ݒ肳B
custom-color-list: u쐬Fv̏lwBBBGGRR  16 ܂ŎwB
                   w肳Ȃꍇ  (#xFFFFFF) ݒ肷B

manual-flags     : CHOOSECOLOR \̂ Flags w肷B
                   manual-flags  nil ̏ꍇ Flags ͎Őݒ肳邪A
                   non-nil ̏ꍇ͎ݒ͈؂ȂȂB

hwnd             : 
hinstance        : 
template-name    : 
lCustData        : 
lpfnHook         : 

y߂lz
lŁuFvu쐬FvԂB
u쐬Fv 16 ̒lȂ郊XgB
X̒l BBGGRR ̐lB"
  (let ((cc (winapi::make-CHOOSECOLOR))
        (custom-colors (si:make-chunk nil (* 4 16)))
        tn flags)
    (si:clear-chunk cc)
    (si:clear-chunk custom-colors)
    ;; tOݒ
    (setq flags manual-flags)
    (unless (integerp flags)
      (setq flags winapi::CC_FULLOPEN)
      (when (integerp color)
        (setq flags (logior flags winapi::CC_RGBINIT)))
      (when lpfnHook
        (setq flags (logior flags winapi::CC_ENABLEHOOK)))
      (when hinstance
        (if template-name
            (setq flags (logior flags winapi::CC_ENABLETEMPLATE))
          (setq flags (logior flags winapi::CC_ENABLETEMPLATEHANDLE)))))
    ;; ftHglݒ
    (unless (integerp color)
      (setq color #xFFFFFF))
    (dotimes (i 16)
      (si:pack-int32 custom-colors (* 4 i) (or (nth i custom-color-list) #xFFFFFF)))
    (unless (integerp hwnd)
      (setq hwnd (ed:get-window-handle)))
    (unless (integerp hinstance)
      (setq hinstance 0))
    (cond
     ((stringp template-name)
      (setq tn (si:make-string-chunk template-name)))
     ((eq (type-of template-name) 'system:chunk)
      (setq tn template-name))
     (t
      (setq tn 0)))
    (unless lpfnHook
      (setq lpfnHook 0))
    (unless lCustData
      (setq lCustData 0))
    ;; \̂ɒl̐ݒ
    (setf (winapi::CHOOSECOLOR-lStructSize cc) (si:chunk-size cc))
    (setf (winapi::CHOOSECOLOR-hwndOwner cc) hwnd)
    (setf (winapi::CHOOSECOLOR-hInstance cc) hinstance)
    (setf (winapi::CHOOSECOLOR-rgbResult cc) color)
    (setf (winapi::CHOOSECOLOR-lpCustColors cc) custom-colors)
    (setf (winapi::CHOOSECOLOR-Flags cc) flags)
    (setf (winapi::CHOOSECOLOR-lCustData cc) lCustData)
    (setf (winapi::CHOOSECOLOR-lpfnHook cc) lpfnHook)
    (setf (winapi::CHOOSECOLOR-lpTemplateName cc) tn)
    ;; s
    (when (/= (winapi::ChooseColor cc) winapi::FALSE)
      (values (si:unpack-int32 cc (c:c-struct-offset-of winapi::CHOOSECOLOR winapi::rgbResult))
              (progn
                (setq custom-color-list nil)
                (dotimes (i 16 (nreverse custom-color-list))
                  (push (si:unpack-int32 custom-colors (* 4 i)) custom-color-list)))))))

(defun choose-font-dialog (&key face-name size bold italic underline strike-out color
                                size-min size-max char-set
                                ;; tOݒ
                                cf-fixed-pitch-only ; Œ蕝tHĝ
                                ;
                                cf-effects          ; underline strike-out color ݒ̕\
                                cf-no-face-sel      ; tHg 
                                cf-no-style-sel     ; X^C   
                                cf-no-size-sel      ; TCY     
                                cf-no-script-sel    ; Zbg 
                                ;
                                cf-select-script    ; w蕶Zbg܂ރtHĝ
                                cf-scripts-only     ; ZbguV{v\Ȃ
                                cf-no-vert-fonts    ; ̃tHĝ
                                cf-no-vector-fonts  ; xNgtHgȂ
                                cf-scalable-only    ; XP[utHĝ
                                cf-tt-only          ; TrueType tHĝ
                                cf-both             ; XN[tHgƃv^tHg̗
                                cf-wysiwyg          ; fBXvCAv^̗Ŏgp\ȃtHĝ
                                manual-flags        ; 蓮ł̑StOݒ
                                ;;
                                hwnd hinstance template-name hdc lCustData lpfnHook)
  "tHgI_CAO\B
yz
face-name         : utHgv̏l       ()
size              ; uTCYv̏l           ()
bold              ; uX^Cvuv̏l (nil, non-nil)
italic            : uX^CvuΆv̏l (nil, non-nil)
underline         : uv̏l             (nil, non-nil)
strike-out        : uv̏l       (nil, non-nil)
color             : uFv̏l               (: BBGGRR)
size-min          : uTCYv̍ŏl       ()
size-max          : uTCYv̍ől       ()
char-set          : uZbgvw           (: ڂ WINAPI mF)

cf-effects        : uvuvuFvݒ̕\ (nil, non-nil)
                    nil ̏ꍇ underline, strike-out, color ̏ݒ
                    ŁA֐̖߂lł underline, strike-out, color
                    ̒lB
cf-no-face-sel    : utHgv                   (nil, non-nil)
cf-no-style-sel   : uX^Cv                     (nil, non-nil)
cf-no-size-sel    : uTCYv                       (nil, non-nil)
cf-no-script-sel  : uZbgv                   (nil, non-nil)

cf-select-script  : w蕶Zbg܂ރtHĝ       (nil, non-nil)
cf-scripts-only   : ZbguV{v\Ȃ     (nil, non-nil)
cf-no-vert-fonts  : ̃tHĝ                 (nil, non-nil)
cf-no-vector-fonts: xNgtHgȂ                   (nil, non-nil)
cf-scalable-only  : XP[utHĝ               (nil, non-nil)
cf-tt-only        : TrueType tHĝ                  (nil, non-nil)
cf-both           : XN[tHgƃv^tHg̗
                                                           (nil, non-nil)
cf-wysiwyg        : fBXvCAv^̗Ŏgp\ȃtHĝ
                                                           (nil, non-nil)

manual-flags      : 蓮ł̑StOݒB
                    CHOOSEFONT \̂ Flags w肷B
                    manual-flags  nil ̏ꍇ Flags ͎yсAcf-* 
                    ݒ肳邪Anon-nil ̏ꍇ͎ݒ͈؂Ȃꂸ cf-*
                    ̎wƂȂAmanual-flags ̒lɂ݂̂Đݒ肳
                    B

hwnd              : 
hinstance         : 
template-name     : 
hdc               : 
lCustData         : 
lpfnHook          : 

y߂lz
ȉ̌`̃tHg񃊃XgԂB
(:face-name \"lr SVbN\" :size 10 :bold t :italic t
 :underline t :strike-out t :color #xFFFFFF)"
  (let ((cf (winapi::make-CHOOSEFONT)) (lf (winapi::make-LOGFONT)) tn flags)
    (si:clear-chunk cf)
    (si:clear-chunk lf)
    ;; tOݒ
    (setq flags manual-flags)
    (unless (integerp flags)
      (setq flags
            (logior winapi::CF_INITTOLOGFONTSTRUCT
                    (if hdc                 winapi::CF_PRINTERFONTS   winapi::CF_SCREENFONTS)
                    (if cf-both             winapi::CF_BOTH           0)
                    (if cf-effects          winapi::CF_EFFECTS        0)
                    (if cf-scripts-only     winapi::CF_SCRIPTSONLY    0)
                    (if cf-no-vector-fonts  winapi::CF_NOVECTORFONTS  0)
                    (if cf-fixed-pitch-only winapi::CF_FIXEDPITCHONLY 0)
                    (if cf-wysiwyg          winapi::CF_WYSIWYG        0)
                    (if cf-scalable-only    winapi::CF_SCALABLEONLY   0)
                    (if cf-tt-only          winapi::CF_TTONLY         0)
                    (if cf-no-face-sel      winapi::CF_NOFACESEL      0)
                    (if cf-no-style-sel     winapi::CF_NOSTYLESEL     0)
                    (if cf-no-size-sel      winapi::CF_NOSIZESEL      0)
                    (if cf-select-script    winapi::CF_SELECTSCRIPT   0)
                    (if cf-no-script-sel    winapi::CF_NOSCRIPTSEL    0)
                    (if cf-no-vert-fonts    winapi::CF_NOVERTFONTS    0)))
      (when lpfnHook
        (setq flags (logior flags winapi::CF_ENABLEHOOK)))
      (when hinstance
        (if template-name
            (setq flags (logior flags winapi::CF_ENABLETEMPLATE))
          (setq flags (logior flags winapi::CF_ENABLETEMPLATEHANDLE))))
      (when (or (integerp size-min) (integerp size-max))
        (setq flags (logior flags winapi::CF_LIMITSIZE))))
    ;; ftHglݒ
    (unless (integerp color)
      (setq color #x000000))
    (unless (integerp size-min)
      (setq size-min 0))
    (unless (integerp size-max)
      (setq size-max #x7fffffff))
    (unless (integerp char-set)
      (setq char-set winapi:SHIFTJIS_CHARSET))
    (unless (integerp hwnd)
      (setq hwnd (ed:get-window-handle)))
    (unless (integerp hdc)
      (setq hdc 0))
    (unless (integerp hinstance)
      (setq hinstance 0))
    (cond
     ((stringp template-name)
      (setq tn (si:make-string-chunk template-name)))
     ((eq (type-of template-name) 'system:chunk)
      (setq tn template-name))
     (t
      (setq tn 0)))
    (unless lpfnHook
      (setq lpfnHook 0))
    (unless lCustData
      (setq lCustData 0))
    ;; l̕ϊ
    (if (integerp size)
        (setq size (- (/ (* size (winapi::GetDeviceCaps (winapi:GetDC 0) winapi::LOGPIXELSY)) 72)))
      (setq size 0))
    (setq bold (if bold winapi::FW_BOLD winapi::FW_DONTCARE))
    (setq italic (if italic winapi::TRUE winapi::FALSE))
    (setq underline (if underline winapi::TRUE winapi::FALSE))
    (setq strike-out (if strike-out winapi::TRUE winapi::FALSE))
    (cond
     ((stringp face-name)
      (setq face-name (si:make-string-chunk face-name)))
     ((eq (type-of face-name) 'system:chunk))
     (t
      (setq face-name (si:make-string-chunk ""))))
    ;; \̂ɒl̐ݒ
    (setf (winapi:LOGFONT-lfHeight lf) size)
    (setf (winapi:LOGFONT-lfWidth lf) 0)
    (setf (winapi:LOGFONT-lfEscapement lf) 0)
    (setf (winapi:LOGFONT-lfOrientation lf) 0)
    (setf (winapi:LOGFONT-lfWeight lf) bold)
    (setf (winapi:LOGFONT-lfItalic lf) italic)
    (setf (winapi:LOGFONT-lfUnderline lf) underline)
    (setf (winapi:LOGFONT-lfStrikeOut lf) strike-out)
    (setf (winapi:LOGFONT-lfCharSet lf) char-set)
    (setf (winapi:LOGFONT-lfOutPrecision lf) 0)
    (setf (winapi:LOGFONT-lfClipPrecision lf) 0)
    (setf (winapi:LOGFONT-lfQuality lf) 0)
    (setf (winapi:LOGFONT-lfPitchAndFamily lf) 0)
    (si:copy-chunk face-name lf (min (si:chunk-size face-name) winapi::LF_FACESIZE)
                   0 (c:c-struct-offset-of winapi::LOGFONT winapi::lfFaceName))
    (setf (winapi::CHOOSEFONT-lStructSize cf) (si:chunk-size cf))
    (setf (winapi::CHOOSEFONT-hwndOwner cf) hwnd)
    (setf (winapi::CHOOSEFONT-hDC cf) hdc)
    (setf (winapi::CHOOSEFONT-lpLogFont cf) lf)
    (setf (winapi::CHOOSEFONT-iPointSize cf) 0)
    (setf (winapi::CHOOSEFONT-Flags cf) flags)
    (setf (winapi::CHOOSEFONT-rgbColors cf) color)
    (setf (winapi::CHOOSEFONT-lCustData cf) lCustData)
    (setf (winapi::CHOOSEFONT-lpfnHook cf) lpfnHook)
    (setf (winapi::CHOOSEFONT-lpTemplateName cf) tn)
    (setf (winapi::CHOOSEFONT-hInstance cf) hinstance)
    (setf (winapi::CHOOSEFONT-lpszStyle cf) 0)
    (setf (winapi::CHOOSEFONT-nFontType cf) 0)
    (setf (winapi::CHOOSEFONT-nSizeMin cf) size-min)
    (setf (winapi::CHOOSEFONT-nSizeMax cf) size-max)
    ;; s
    (when (/= (winapi::ChooseFont cf) winapi::FALSE)
      (list :face-name
            (si:unpack-string lf (c:c-struct-offset-of winapi::LOGFONT winapi::lfFaceName) winapi::LF_FACESIZE)
            :size
            (/ (si:unpack-int32 cf (c:c-struct-offset-of winapi::CHOOSEFONT winapi::iPointSize)) 10)
            :bold
            (>= (si:unpack-int32 lf (c:c-struct-offset-of winapi::LOGFONT winapi::lfWeight)) winapi::FW_BOLD)
            :italic
            (= (si:unpack-uint8 lf (c:c-struct-offset-of winapi::LOGFONT winapi::lfItalic)) winapi::TRUE)
            :underline
            (= (si:unpack-uint8 lf (c:c-struct-offset-of winapi::LOGFONT winapi::lfUnderline)) winapi::TRUE)
            :strike-out
            (= (si:unpack-uint8 lf (c:c-struct-offset-of winapi::LOGFONT winapi::lfStrikeOut)) winapi::TRUE)
            :color
            (si:unpack-int32 cf (c:c-struct-offset-of winapi::CHOOSEFONT winapi::rgbColors))))))

;;; winapi/commdlg.l ends here
